Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java	(revision 527)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/SWTChartsComponentsProvider.java	(revision 528)
@@ -40,6 +40,7 @@
 import org.txm.chartsengine.core.ChartCreator;
 import org.txm.chartsengine.core.ChartsEngine;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.rcp.editors.ChartEditorInput;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
 import org.txm.chartsengine.rcp.events.EventCallBack;
@@ -51,7 +52,6 @@
 import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
 import org.txm.core.results.TXMResult;
 import org.txm.rcp.editors.SplitedGenericMultiPageEditor;
-import org.txm.rcp.editors.TXMEditorPart;
 import org.txm.rcp.preferences.TXMPreferencePage;
 import org.txm.utils.logger.Log;
 
@@ -68,9 +68,9 @@
 	
 	// FIXME: should be done in an activator?
 	static	{	
-	// Initializes the SWT Charts Components provider according to the current charts engine and its output format
-	SWTChartsComponentsProvider.createSWTChartsComponentsProviders();
-	SWTChartsComponentsProvider.setCurrrentComponentsProvider(ChartsEngine.getCurrent());
+		// Initializes the SWT Charts Components provider according to the current charts engine and its output format
+		SWTChartsComponentsProvider.createSWTChartsComponentsProviders();
+		SWTChartsComponentsProvider.setCurrrentComponentsProvider(ChartsEngine.getCurrent());
 	}
 	
 	
@@ -105,7 +105,6 @@
 	 */
 	protected Properties keyboardBindingProperties;
 
-
 	
 	/**
 	 * Installed SWT charts components providers.
@@ -149,75 +148,35 @@
 //		}
 	}
 
-	
+	/**
+	 * 
+	 * @param chartsEngine
+	 */
 	public SWTChartsComponentsProvider(ChartsEngine chartsEngine) {
 		this(chartsEngine, new ___MouseBindingProperties(), new ___KeyboardBindingProperties());
 	}
 
 	
+	/**
+	 * 
+	 */
 	public SWTChartsComponentsProvider() {
 		this(null);
 	}
 
 	
-	
 	/**
-	 * Creates and return a SWT EditorPart filled with a new chart for the specified result and chart type.
-	 * @param editorInputName
+	 * Creates a <code>ChartEditorInput</code> for the specified chart result.
 	 * @param result
-	 * @param preferencesNode
-	 * @param chartType
-	 * @return
+	 * @return a <code>ChartEditorInput</code>
 	 */
-	public ChartEditorPart createChartEditor(TXMResult result, String chartType) {
-		ChartEditorInput chartEditorInput = new ChartEditorInput(this, result, chartType, null);
-
-		//FIXME: need to try to do the chart creation in openEditor() with computeChart() (tested without success... need to check again)
-		// create the chart from the charts engine chart creator extension
-		this.createChart(chartEditorInput, result, chartType);
-		
-		ChartEditorPart editor = new ChartEditorPart(this, chartEditorInput);
-		return editor;
+	public ChartEditorInput createChartEditorInput(ChartResult result) {
+		return new ChartEditorInput(this, result);
 	}
-
 	
 	/**
-	 * Creates and return a SWT EditorPart filled with a new chart for the specified result.
-	 * @param editorInputName
-	 * @param result
-	 * @param preferencesNode
-	 * @return
-	 */
-	public ChartEditorPart createChartEditor(TXMResult result) {
-		return this.createChartEditor(result, null);
-	}
-	
-//	/**
-//	 * Creates and return a SWT EditorPart filled with a new chart for the specified result.
-//	 * @param result
-//	 * @param preferencesNode
-//	 * @param chartType
-//	 * @return
-//	 */
-//	public ChartEditorPart createChartEditor(TXMResult result, String preferencesNode, String chartType) {
-//		return this.createChartEditor(this.getChartsEngine().getChartCreator(result.getClass(), chartType).getFileNamePrefix(), result, preferencesNode, chartType);
-//	}
-	
-	/**
-	 * Creates a new chart for the specified result data and saves it in the specified editor input.
-	 * A chart editor created with the editor input will be filled with chart.
+	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
 	 * 
-	 * @param chartEditorInput
-	 * @param result
-	 * @param preferencesNode
-	 */
-	public void createChart(ChartEditorInput chartEditorInput, TXMResult result)	{
-		this.createChart(chartEditorInput, result, chartEditorInput.getChartType()); 
-	}
-	
-	/**
-	 * Creates a new chart for the specified result data and chart type and save it in the specified editor input.
-	 * 
 	 * @param chartsEngine
 	 * @param chartEditorInput
 	 * @param result
@@ -225,10 +184,10 @@
 	 * @param chartType
 	 * @return
 	 */
-	protected abstract boolean createChart(ChartsEngine chartsEngine, ChartEditorInput chartEditorInput, TXMResult result, String chartType);
+	protected abstract boolean createChartContainer(ChartsEngine chartsEngine, ChartEditorInput chartEditorInput);
 	
 	/**
-	 * Creates a new chart for the specified result data and chart type and save it in the specified editor input.
+	 * Creates a new chart container for the specified <code>ChartResult</code> save it in the specified <code>ChartEditorInput</code>.
 	 * 
 	 * @param chartEditorInput
 	 * @param result
@@ -236,8 +195,8 @@
 	 * @param chartType
 	 * @return
 	 */
-	protected boolean createChart(ChartEditorInput chartEditorInput, TXMResult result, String chartType)	{
-		return this.createChart(this.getChartsEngine(), chartEditorInput, result, chartType);
+	public boolean createChartContainer(ChartEditorInput chartEditorInput)	{
+		return this.createChartContainer(this.getChartsEngine(), chartEditorInput);
 	}
 	
 	
@@ -249,27 +208,16 @@
 	 * @param chartType
 	 * @return <code>True</code>, if a chart creator has been found and the chart has been updated, otherwise <code>false</code>
 	 */
-	public boolean updateChart(ChartEditorPart editor, String chartType)	{
-		ChartCreator chartCreator = this.chartsEngine.getChartCreator(editor.getResultData().getClass(), chartType);
-		if(chartCreator != null)	{
-			chartCreator.updateChart(editor.getChart(), editor.getResultData());
-			return true;
+	public boolean updateChart(ChartEditorPart editor)	{
+		try {
+			return editor.getResultData().compute(true);
 		}
+		catch(Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
 		return false;
 	}
-	
-	
-	/**
-	 * Updates the specified chart stored in the editor and according to the stored TXM result.
-	 * @param editor
-	 * @param command
-	 * @param params
-	 * @return <code>True</code>, if a chart creator has been found and the chart has been updated, otherwise <code>false</code>
-	 */
-	public boolean updateChart(ChartEditorPart editor)	{
-		return this.updateChart(editor, editor.getChartType());
-	}
-	
 
 	
 	/**
@@ -631,18 +579,7 @@
 		return this.openEditor(chartEditorInput, chartEditorInput.getResult().getClass().getName());
 	}
 
-	/**
-	 * Opens the specified <code>ChartEditorPart</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
-	 * The chart type is the editor input result data class name.
-	 * @param chartEditorInput
-	 * @param editorPartId
-	 * @return
-	 */
-	public ChartEditorPart openEditor(ChartEditorInput chartEditorInput, String editorPartId)	{
-		return this.openEditor(chartEditorInput, editorPartId, null);	
-	}
 	
-	
 	/**
 	 * Opens the <code>ChartEditorPart</code> specified by its id and ChartEditorInput in the active page and registers the event listeners and context menus according to the <code>EventCallBack</code> installed extensions. 
 	 * @param chartEditorInput
@@ -651,7 +588,7 @@
 	 * @return
 	 */
 	// FIXME: this method have some trouble when calling through a progress dialog
-	public ChartEditorPart openEditor(ChartEditorInput chartEditorInput, String editorPartId, String chartType)	{
+	public ChartEditorPart openEditor(ChartEditorInput chartEditorInput, String editorPartId)	{
 
 		ChartEditorPart openedChartEditorPart = null;
 
@@ -666,7 +603,7 @@
 		Log.info("SWTChartsComponentsProvider.openEditor(): opening editor with id " + editorPartId);
 		
 		// if the editor is already open or the charts engine can create the specified chart type
-		if(isAlreadyOpened || this.chartsEngine.canCreateChart(chartEditorInput.getResult().getClass(), chartType))	{
+		if(isAlreadyOpened || this.chartsEngine.canCreateChart(chartEditorInput.getResult().getClass(), chartEditorInput.getChartType()))	{
 			
 			//Log.info(this.name + " - Opening editor for result data type " + chartEditorInput.getResultData().getClass() + " and editor id " + editorPartId);
 
@@ -714,7 +651,7 @@
 			for(int i = 0; i < ChartsEngine.getChartsEngines().size() && !canCreate; i++) {
 				if(ChartsEngine.getChartsEngines().get(i) != this.chartsEngine)	{
 					ChartsEngine chartsEngine = ChartsEngine.getChartsEngines().get(i);
-					canCreate = chartsEngine.canCreateChart(chartEditorInput.getResult().getClass(), chartType);
+					canCreate = chartsEngine.canCreateChart(chartEditorInput.getResult().getClass(), chartEditorInput.getChartType());
 					// get a provider that can manage the charts engine
 					if(canCreate)	{
 						SWTChartsComponentsProvider provider = SWTChartsComponentsProvider.getComponentsProvider(chartsEngine);
@@ -722,7 +659,7 @@
 							provider.setChartsEngine(chartsEngine);
 							chartEditorInput.setSWTChartsComponentsProvider(provider);
 							Log.warning(provider.toString());
-							return provider.openEditor(chartEditorInput, editorPartId, chartType);
+							return provider.openEditor(chartEditorInput, editorPartId);
 						}
 					}
 				}
@@ -742,56 +679,12 @@
 	 * @param params
 	 * @return
 	 */
-	public ChartEditorPart openEditor(TXMResult result, String chartType)	{
-		return this.openEditor(this.createChartEditor(result, chartType), chartType);
+	public ChartEditorPart openEditor(ChartResult result)	{
+		return this.openEditor(this.createChartEditorInput(result), result.getClass().getName());
 	}
 	
-	/**
-	 * 
-	 * @param editorInputName
-	 * @param result
-	 * @param params
-	 * @return
-	 */
-	public ChartEditorPart openEditor(TXMResult result)	{
-		return this.openEditor(result, null);
-	}
 	
-	
 	/**
-	 * Opens the specified <code>ChartEditorPart</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
-	 * The ID of the editor is the editor input result data class name.
-	 * @param editorPart
-	 * @return
-	 */
-	public ChartEditorPart openEditor(ChartEditorPart editorPart)	{
-		return this.openEditor(editorPart, null);
-	}
-	
-	/**
-	 * Opens the specified <code>ChartEditorPart</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
-	 * The ID of the editor is the editor input result data class name.
-	 * @param chartEditorInput
-	 * @return
-	 */
-	public ChartEditorPart openEditor(ChartEditorPart editorPart, String chartType)	{
-		return this.openEditor(editorPart, editorPart.getEditorInput().getResult().getClass().getName(), chartType);
-	}
-	
-	
-	/**
-	 * Opens the specified <code>ChartEditorPart</code> in the active page and registers the event listeners and context menus according to the type of the chart editor part.
-	 * @param editorPart
-	 * @param editorId
-	 * @return
-	 */
-	public ChartEditorPart openEditor(ChartEditorPart editorPart, String editorId, String chartType)	{
-		return this.openEditor(editorPart.getEditorInput(), editorId, chartType);
-	}
-	
-	
-	
-	/**
 	 * Initializes the default context menus.
 	 * @param composite
 	 */
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java	(revision 527)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java	(revision 528)
@@ -4,6 +4,8 @@
 import java.io.File;
 import java.util.ArrayList;
 
+import javax.swing.JComponent;
+
 import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.IProgressMonitor;
@@ -15,20 +17,22 @@
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Group;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IEditorSite;
 import org.eclipse.ui.IPartListener;
 import org.eclipse.ui.IWorkbenchPart;
+import org.eclipse.ui.PartInitException;
 import org.eclipse.ui.PlatformUI;
-import org.eclipse.ui.contexts.IContextService;
 import org.eclipse.ui.part.EditorPart;
 import org.eclipse.ui.part.MultiPageEditorPart;
 import org.txm.chartsengine.core.ChartsEngine;
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
 import org.txm.chartsengine.rcp.events.EventCallBack;
 import org.txm.chartsengine.rcp.events.EventCallBackHandler;
 import org.txm.chartsengine.rcp.swt.AdvancedChartEditorToolBar;
 import org.txm.chartsengine.rcp.swt.ChartComposite;
 import org.txm.chartsengine.rcp.swt.ChartEditorToolBar;
-import org.txm.core.results.TXMResult;
 import org.txm.rcp.editors.TXMEditorPart;
 import org.txm.rcp.editors.TXMEditorToolBar;
 import org.txm.rcp.utils.JobHandler;
@@ -95,37 +99,34 @@
 	}
 
 	
-	
+
 	/**
 	 * 
 	 * @param swtComponentsProvider
-	 * @param titleImage
-	 * @param result
-	 * @param chartContainer
-	 */
-	public ChartEditorPart(SWTChartsComponentsProvider swtComponentsProvider, TXMResult result, String chartType, Object chartContainer) {
-		this(swtComponentsProvider, new ChartEditorInput(swtComponentsProvider, result, chartType, chartContainer));
-	}
-	
-	
-	/**
-	 * 
-	 * @param swtComponentsProvider
 	 * @param chartEditorInput
 	 */
-	public ChartEditorPart(SWTChartsComponentsProvider swtComponentsProvider, ChartEditorInput chartEditorInput) {
+	protected ChartEditorPart(SWTChartsComponentsProvider swtComponentsProvider, ChartEditorInput chartEditorInput) {
 		this.setInput(chartEditorInput);
 		this.setPartName(chartEditorInput.getName());
 		
 		this.wasAlreadyOpened = false;
 	}
 
-	
+	/**
+	 * 
+	 * @param chartEditorInput
+	 */
 	public ChartEditorPart(ChartEditorInput chartEditorInput) {
 		this(SWTChartsComponentsProvider.getCurrent(), chartEditorInput);
 	}
 	
 
+	@Override
+	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
+		
+		
+		super.init(site, input);
+	}
 	
 	@Override
 	public void createPartControl(Composite parent) {
@@ -145,6 +146,7 @@
 		
 		// Toolbar
 		this.chartToolBar = new ChartEditorToolBar(this.getTopToolBarContainer(), SWT.FLAT | SWT.RIGHT, this);
+		//this.chartToolBar = new ChartEditorToolBar(this.topToolBar, SWT.FLAT | SWT.RIGHT, this);
 		//this.chartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
 
 		
@@ -223,19 +225,27 @@
 		
 		// Advanced tool bar
 		//this.advancedToolBarComposite = new Composite(parent, SWT.NONE);
-		Group group = this.topToolBar.installGroup("Rendering parameters", "Show/Hide rendering parameters", "platform:/plugin/org.txm.chartsengine.rcp/icons/show_rendering_parameters.png");
+		Group group = this.topToolBar.installGroup("Rendering parameters", "Show/Hide rendering parameters", "platform:/plugin/org.txm.chartsengine.rcp/icons/show_rendering_parameters.png", false);
 		this.advancedChartToolBar = new AdvancedChartEditorToolBar(group, SWT.FLAT, this);
 //		this.advancedToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
 //		this.advancedToolBarComposite.pack(true);
+
+		// Remove parent composites
+		this.displayArea.dispose();
+		this.bottomToolBar.dispose();
 		
 		// Chart composite
-		ChartComposite chartComposite = this.getSWTChartsComponentsProvider().createComposite(this, parent);
+		this.chartComposite = this.getSWTChartsComponentsProvider().createComposite(this, parent);
 		GridData gd = new GridData(GridData.FILL_BOTH);
 //		gd.grabExcessVerticalSpace = true;
 //		gd.grabExcessHorizontalSpace = true;
-//		gd.horizontalSpan = 2; // 2 for match the command parameters toolbar AND the chart toolbar
-		chartComposite.setLayoutData(gd);
+		//gd.horizontalSpan = 2; // 2 for match the command parameters toolbar AND the chart toolbar
+		this.chartComposite.setLayoutData(gd);
 		
+		
+		// Re-add the bottom toolbar
+		this.bottomToolBar = new TXMEditorToolBar(parent, SWT.FLAT, "bottom", this);
+		
 		// FIXME: open dialog box message if the composite doesn't contain any chart (typically when the charts engine doesn't contain chart creator for the specified result data type)
 //		if(composite.getChart() == null)	{
 //			MessageDialog.openWarning(parent.getShell(), "Warning", "Current charts engine can not create chart for " + this.getResultData().getClass().getSimpleName() + " result type. You can set another charts engine in the preferences.");
@@ -246,25 +256,10 @@
 		//parent.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
 
 		
+		this.computeChart(false);
 		
-		// initialize the default shared context menus as Export, etc.
-		SWTChartsComponentsProvider.initDefaultContextMenus(chartComposite);
-
 		
-		// registers user entries event call back extensions
-		this.registerEventCallBackExtensions();
 		
-		//FIXME: test to contribute to menu only in some context
-		// create chart editor part context
-//		IContextService contextService = (IContextService)getSite().getService(IContextService.class);
-//		contextService.activateContext(ChartEditorPart.class.getName());
-//		// create chart composite context
-//		contextService.activateContext(this.chartComposite.getClass().getName());
-		
-		//FIXME: description test
-		//this.setContentDescription("details");
-		//this.setContentDescription(this.getResultData().getDetails());
-		
 	}
 
 
@@ -422,6 +417,7 @@
 	 */
 	public void computeChart(String jobName, final boolean update, boolean setUser, final boolean resetView, final boolean clearChartItemsSelection) {
 		
+		
 		JobHandler job = new JobHandler(jobName) {
 
 		    @Override
@@ -430,16 +426,32 @@
 		    	this.runInit(monitor);
 		    	
 		    	try {
-					// creating/updating
-					monitor.beginTask("Computing", IProgressMonitor.UNKNOWN);
+
+		    		// computing result
+					monitor.beginTask("Computing", 100);
+
+		    		// FIXME: temporary solution, should call super.computeResult() ?
+					if(getResultData().isDirty())	{
+						getResultData().compute(update, monitor);
+					}
+		    		
 					
-					if(update)	{
-						updateChart();
+					// creating/updating chart
+					monitor.subTask("computing chart");
+
+					getResultData().computeChart(update);
+
+					if(!update)	{
+						createChartContainer();
 					}
-					else	{
-						createChart();
-					}
 
+					// FIXME: long process test
+//					for(long i = 0; i < 9000000000L; i++)	{
+//						;
+//					}
+
+					monitor.worked(25);
+					
 					// cancel
 					if(monitor.isCanceled())	{
 						close(true);
@@ -447,9 +459,38 @@
 					}
 					
 					// loading
-					monitor.setTaskName("Loading");
+					monitor.subTask("loading chart");
 					loadChart(resetView, clearChartItemsSelection);
 
+					if(!update)	{
+						// Initialize Swing/AWT events delegation.
+						this.syncExec(new Runnable() {
+							@Override
+							public void run() {
+								// initialize the default shared context menus as Export, etc.
+								SWTChartsComponentsProvider.initDefaultContextMenus(chartComposite);
+
+								
+								// registers user entries event call back extensions
+								registerEventCallBackExtensions();
+								
+								//FIXME: test to contribute to menu only in some context
+								// create chart editor part context
+//								IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+//								contextService.activateContext(ChartEditorPart.class.getName());
+//								// create chart composite context
+//								contextService.activateContext(this.chartComposite.getClass().getName());
+								
+								//FIXME: description test
+								//this.setContentDescription("details");
+								//this.setContentDescription(this.getResultData().getDetails());
+
+								initializeAWTDelegationListeners();
+							}
+						});
+					}
+
+					
 					// FIXME: refresh the tree node
 //				getSite().getShell().getDisplay().syncExec(new Runnable() {
 //					@Override
@@ -464,6 +505,7 @@
 				}
 		    	// for user direct canceling
 		    	catch(ThreadDeath td) {
+		    		// FIXME should clean() and/or set the result as dirty?
 		    		close(true);
 		    		return Status.CANCEL_STATUS;
 		    	}
@@ -482,6 +524,14 @@
 
 
 
+	/**
+	 * Initialize Swing/AWT events delegation.
+	 * @param swingComponent
+	 */
+	protected void initializeAWTDelegationListeners()	{
+		this.getChartComposite().getChartComponent().setChartEditor(this);
+		SWTChartsComponentsProvider.initializeAWTDelegationListeners(this, (JComponent) this.getEditorInput().getChartContainer());
+	}
 
 	/**
 	 * Convenience method the get the casted linked editor input.
@@ -570,31 +620,11 @@
 	
 	
 	
-	/**
-	 * Updates the specified chart stored in the editor and according to the stored TXM result.
-	 * @return <code>True</code>, if a chart creator has been found and the chart has been updated, otherwise <code>false</code>
-	 */
-	public boolean updateChart()	{
-		return this.getSWTChartsComponentsProvider().updateChart(this);
+	public void createChartContainer()	{
+		this.getSWTChartsComponentsProvider().createChartContainer(this.getEditorInput());
 	}
 	
 	/**
-	 * Creates a new chart for the specified result data and save it in the current editor input.
-	 * @param result
-	 * @param preferencesNode
-	 */
-	public void createChart(TXMResult result)	{
-		this.getSWTChartsComponentsProvider().createChart(this.getEditorInput(), result);
-	}
-	
-	/**
-	 * Creates a new chart for current stored result and save it in the current editor input.
-	 */
-	public void createChart()	{
-		this.createChart(this.getResultData());
-	}
-	
-	/**
 	 * Disposes the editor.
 	 * Implementations using a Composite to embed AWT/Swing components should manually call this.composite.dispose() in the redefined method.
 	 */
@@ -627,7 +657,7 @@
 	 * @return
 	 */
 	public String getChartType()	{
-		return this.getEditorInput().getChartType();
+		return this.getResultData().getChartType();
 	}
 	
 	/**
@@ -635,9 +665,15 @@
 	 * @return
 	 */
 	public Object getChart()	{
-		return this.chartComposite.getChart();
+		return this.getResultData().getChart();
 	}
 
+	@Override
+	public ChartResult getResultData()	{
+		return (ChartResult) this.getEditorInput().getResult();
+	}
+
+	
 	/**
 	 * Returns the chart components provider associated with the editor (through its <code>ChartEditorInput</code>).
 	 * @return
@@ -835,9 +871,9 @@
 	/**
 	 * @param composite the composite to set
 	 */
-	public void setComposite(ChartComposite composite) {
-		this.chartComposite = composite;
-	}
+//	public void setComposite(ChartComposite composite) {
+//		this.chartComposite = composite;
+//	}
 
 
 
@@ -860,6 +896,15 @@
 	}
 
 
+	/**
+	 * Opens an editor for the specified result.
+	 * @param result
+	 * @return
+	 */
+	public static ChartEditorPart openEditor(ChartResult result)	{
+		return SWTChartsComponentsProvider.getCurrent().openEditor(result);
+	}
+	
 
 	/**
 	 * Checks whatever the chart composite has the focus or not.
@@ -880,4 +925,13 @@
 	protected void initializeFields() {
 		// TODO Auto-generated method stub
 	}
+
+
+
+	/**
+	 * @return the chartComposite
+	 */
+	public ChartComposite getChartComposite() {
+		return chartComposite;
+	}
 }
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorInput.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorInput.java	(revision 527)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorInput.java	(revision 528)
@@ -4,6 +4,7 @@
 import org.eclipse.ui.IPersistableElement;
 import org.txm.chartsengine.core.ChartsEngine;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
+import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.TXMResult;
@@ -20,10 +21,6 @@
 	@Deprecated
 	protected String name;
 	
-	/**
-	 * Chart type.
-	 */
-	protected String chartType;
 	
 	/**
 	 * SWT chart components provider used to create the chart editor.
@@ -38,6 +35,8 @@
 	protected Object chartContainer;
 
 	
+	//protected Object chart;
+	
 	/**
 	 * Creates a chart editor input linked to the current SWT charts components provider.
 	 * @param result
@@ -60,27 +59,15 @@
 	/**
 	 * Creates a chart editor input linked to the specified SWT charts components provider.
 	 * @param swtComponentsProvider
-	 * @param result
-	 * @param preferencesNodeQualifier
-	 * @param chartType
-	 */
-	public ChartEditorInput(SWTChartsComponentsProvider swtComponentsProvider, TXMResult result, String chartType) {
-		this(swtComponentsProvider, result, chartType, null);
-	}
-
-	/**
-	 * Creates a chart editor input linked to the specified SWT charts components provider.
-	 * @param swtComponentsProvider
 	 * @param name
 	 * @param result
 	 * @param preferencesNodeQualifier
 	 * @param chartType
 	 * @param chartContainer
 	 */
-	public ChartEditorInput(SWTChartsComponentsProvider swtComponentsProvider, TXMResult result, String chartType, Object chartContainer) {
+	public ChartEditorInput(SWTChartsComponentsProvider swtComponentsProvider, TXMResult result, Object chartContainer) {
 		super(result);
 		this.swtChartsComponentsProvider = swtComponentsProvider;
-		this.chartType = chartType;
 		this.chartContainer = chartContainer;
 	}
 
@@ -177,7 +164,12 @@
 		this.chartContainer = chartContainer;
 	}
 
+//	public void setChart(Object chart) {
+//		this.chart = chart;
+//	}
 
+	
+
 	/**
 	 * Set the <code>SWTChartsComponentsProvider</code> to link to this editor input and to use for reading the chart object.
 	 * @param swtChartsComponentsProvider the swtChartsComponentsProvider to set
@@ -193,11 +185,14 @@
 	 * @return the chartType or <code>null</code> if there only one chart type needed for the linked <code>TXMResult</code>. 
 	 */
 	public String getChartType() {
-		return chartType;
+		return this.getResult().getChartType();
 	}
 
+	@Override
+	public ChartResult getResult() {
+		return (ChartResult) this.result;
+	}
 
-
 	/**
 	 * Sets and updates the local preferences node qualifier from the result data.
 	 * Synchronizes the local preferences node with the result data type, chart type, etc.
@@ -207,11 +202,11 @@
 		//FIXME: to call when implemented in parent class
 		//super.syncLocalPreferencesNode();
 		// FIXME: persistence test
-		if(this.chartType != null)	{
-			TXMPreferences.putLocalString(this.result, ChartsEnginePreferences.CHART_TYPE, this.chartType);
+		if(this.getResult().getChartType() != null)	{
+			TXMPreferences.putLocal(this.result, ChartsEnginePreferences.CHART_TYPE, this.getResult().getChartType());
 		}
 		
-		TXMPreferences.putLocalString(this.result, ChartsEnginePreferences.RESULT_DATA_TYPE, this.result.getClass().getName());
+		TXMPreferences.putLocal(this.result, ChartsEnginePreferences.RESULT_DATA_TYPE, this.result.getClass().getName());
 	}
 	
 
@@ -225,5 +220,18 @@
 		}
 		return false;
 	}
+
+	/**
+	 * Gets the chart object. According to the used charts engine, it can be a file, an UI component, etc.
+	 * @return
+	 */
+	public Object getChart() {
+		try {
+			return ((ChartResult) this.result).getChart();
+		}
+		catch(Exception e) {
+		}
+		return null;
+	}
 	
 }
